###########################################################################
# Insert one TMS320C671x CPU into JTAG chain
# with emulator as parent 
###########################################################################
set DEV0 [ xds add TMS320C6710 $EMU ]

###########################################################################
# Select $DEV0 CPU as target device DEV, to which flash/EEPROM is connected
###########################################################################
set DEV $DEV0

###########################################################################
# CPU clock frequency
###########################################################################
set cpu_clock    10000000
set periph_clock 10000000

###########################################################################
# for SPI-interfaced FLASH IC's
# set information on CS signal

# CS signal port is 0xB0000000 in CPU's addr space
set cs_port_address 0xB0000000
# CS signal port is in mempage 0
set cs_port_mempage 0
# CS signal port width (0 - 8-bit, 1 - 16-bit, 2 - 32-bit)
set cs_port_width 2
# CS signal bit is 0x0001
set cs_port_bit 0x0001
# CS signal polarity is 0, active low
set cs_port_polarity 0


###########################################################################
# change this proc according to schematic of your
# board to initialize all of the environment of EEPROM/Flash
# for correct programming
###########################################################################
proc UserInitCPUEnv { dev } {

  upvar 1 flash_type flash_type

}

###########################################################################
# change this proc according to schematic of your
# board to reset all of the environment of EEPROM/Flash
# for normal operation after programming
###########################################################################
proc UserFinishCPUEnv { dev } {

  upvar 1 flash_type flash_type

}
