#
# Setup specific parameters for Classic NOR flash
# after target-side code loaded and started, 
# after ready-state breakpoint occured
#

# transfer sector table to target-side code

getsym $coff _sector_def

# calculate address increment.
# for CPU's with 8-bit word increment is 4
# for CPU's with 16-bit word increment is 2
# for CPU's with 32-bit word increment is 1
set offset_incr [expr 1 << (2-$word_width)]
if { [string equal $cpu_type "TMS320C5500"] &&
     ($_sector_def_pg == 0) } {
  set offset_incr 4
}

set ii 0
foreach sector $internal_flash_sectors {
  set secdef_entry [expr [lindex $sector 0] | ([lindex $sector 1] << 24)]
  PutLong $DEV $_sector_def_addr $_sector_def_pg $secdef_entry
  set _sector_def_addr [expr $_sector_def_addr + $offset_incr]
  incr ii
}

getsym $coff _sectors
PutLong $DEV $_sectors_addr $_sectors_pg $ii

if { [string equal $cpu_type "TMS470R1B"] } {

  # Transfer Flash programming password to target-side-code

  getsym $coff _flsh_passwd

  PutLong $DEV $_flsh_passwd_addr $_flsh_passwd_pg [lindex $flash_password 0]
  PutLong $DEV [expr $_flsh_passwd_addr + $offset_incr] $_flsh_passwd_pg [lindex $flash_password 1]
  PutLong $DEV [expr $_flsh_passwd_addr + ($offset_incr * 2)] $_flsh_passwd_pg [lindex $flash_password 2]
  PutLong $DEV [expr $_flsh_passwd_addr + ($offset_incr * 3)] $_flsh_passwd_pg [lindex $flash_password 3]

  # transfer Keys programming enable flag
  getsym $coff _fProgKeys
  if { [info exists EnableKeysProgramming] } {
    PutLong $DEV $_fProgKeys_addr $_fProgKeys_pg $EnableKeysProgramming
    puts " \7 !WARNING! Programming of flash keys is enabled"
  } else {
    PutLong $DEV $_fProgKeys_addr $_fProgKeys_pg 0
  }

}

if { [string equal $cpu_type "TMS320C2800"] } {

  # transfer Keys programming enable flag
  getsym $coff _fProgKeys
  if { [info exists EnableKeysProgramming] } {
    PutLong $DEV $_fProgKeys_addr $_fProgKeys_pg $EnableKeysProgramming
    puts " \7 !WARNING! Programming of flash keys is enabled"
  } else {
    PutLong $DEV $_fProgKeys_addr $_fProgKeys_pg 0
  }

}
