#
# Transfer interface type to target-side code

getsym $coff _iftype
PutLong $DEV $_iftype_addr $_iftype_pg $iftype

#
# Transfer controller base address to target-side code
#
if { [info exists ctrlr_base] } {
  getsym $coff _ctrlr_base
  PutLong $DEV $_ctrlr_base_addr $_ctrlr_base_pg $ctrlr_base
}

#
# Initialization for parallel data bus controller
#

#
# Transfer interface parameters to target-side code
#
getsym $coff _dbus_shift
getsym $coff _base_address
getsym $coff _xbus_width

#
# if defined "flash_base_offset" add it to flash_base
#
if { [info exists flash_base_offset] } {
  set flash_base [expr $flash_base + $flash_base_offset]
}

PutLong $DEV $_base_address_addr $_base_address_pg $flash_base

PutLong $DEV $_dbus_shift_addr $_dbus_shift_pg $flash_data_shift
PutLong $DEV $_xbus_width_addr $_xbus_width_pg $xbus_width

#
# Initialize data bus if needed
#
if { [string equal $cpu_type "TMS320C5500"] } {

  if { $xbus_width == 2 } {
    # initialize all CE spaces to 32-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 32-bit wide async mode..." 

    # EMIF_CE0x
    PutShort $DEV [expr $ctrlr_base + 4] 2 0xFF23
    PutShort $DEV [expr $ctrlr_base + 5] 2 0xFFFF
    # EMIF_CE1x 
    PutShort $DEV [expr $ctrlr_base + 2] 2 0xFF23
    PutShort $DEV [expr $ctrlr_base + 3] 2 0xFFFF
    # EMIF_CE2x
    PutShort $DEV [expr $ctrlr_base + 8] 2 0xFF23
    PutShort $DEV [expr $ctrlr_base + 9] 2 0xFFFF
    # EMIF_CE3x 
    PutShort $DEV [expr $ctrlr_base + 0x0A] 2 0xFF23
    PutShort $DEV [expr $ctrlr_base + 0x0B] 2 0xFFFF

  } elseif { $xbus_width == 1 } { 
    # initialize all CE spaces to 16-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 16-bit wide async mode..." 

    # EMIF_CE0x
    PutShort $DEV [expr $ctrlr_base + 4] 2 0xFF13
    PutShort $DEV [expr $ctrlr_base + 5] 2 0xFFFF
    # EMIF_CE1x 
    PutShort $DEV [expr $ctrlr_base + 2] 2 0xFF13
    PutShort $DEV [expr $ctrlr_base + 3] 2 0xFFFF
    # EMIF_CE2x
    PutShort $DEV [expr $ctrlr_base + 8] 2 0xFF13
    PutShort $DEV [expr $ctrlr_base + 9] 2 0xFFFF
    # EMIF_CE3x 
    PutShort $DEV [expr $ctrlr_base + 0x0A] 2 0xFF13
    PutShort $DEV [expr $ctrlr_base + 0x0B] 2 0xFFFF

  } else {
    # initialize all CE spaces to 8-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 8-bit wide async mode..." 

    # EMIF_CE0x
    PutShort $DEV [expr $ctrlr_base + 4] 2 0xFF03
    PutShort $DEV [expr $ctrlr_base + 5] 2 0xFFFF
    # EMIF_CE1x 
    PutShort $DEV [expr $ctrlr_base + 2] 2 0xFF03
    PutShort $DEV [expr $ctrlr_base + 3] 2 0xFFFF
    # EMIF_CE2x
    PutShort $DEV [expr $ctrlr_base + 8] 2 0xFF03
    PutShort $DEV [expr $ctrlr_base + 9] 2 0xFFFF
    # EMIF_CE3x 
    PutShort $DEV [expr $ctrlr_base + 0x0A] 2 0xFF03
    PutShort $DEV [expr $ctrlr_base + 0x0B] 2 0xFFFF

  }

}

if { [string equal $cpu_type "TMS320C6710"] ||
     [string equal $cpu_type "TMS320C6410"] } {

  if { $xbus_width == 2 } {
    # initialize all CE spaces to 32-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 32-bit wide async mode..." 

    # CECTL0
    PutLong $DEV [expr $ctrlr_base + 0x08] 0 0xFFFFFF23
    # CECTL1
    PutLong $DEV [expr $ctrlr_base + 0x04] 0 0xFFFFFF23
    # CECTL2
    PutLong $DEV [expr $ctrlr_base + 0x10] 0 0xFFFFFF23
    # CECTL3
    PutLong $DEV [expr $ctrlr_base + 0x14] 0 0xFFFFFF23

  } elseif { $xbus_width == 1 } { 
    # initialize all CE spaces to 16-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 16-bit wide async mode..." 

    # CECTL0
    PutLong $DEV [expr $ctrlr_base + 0x08] 0 0xFFFFFF13
    # CECTL1
    PutLong $DEV [expr $ctrlr_base + 0x04] 0 0xFFFFFF13
    # CECTL2
    PutLong $DEV [expr $ctrlr_base + 0x10] 0 0xFFFFFF13
    # CECTL3
    PutLong $DEV [expr $ctrlr_base + 0x14] 0 0xFFFFFF13

  } else {
    # initialize all CE spaces to 8-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 8-bit wide async mode..." 

    # CECTL0
    PutLong $DEV [expr $ctrlr_base + 0x08] 0 0xFFFFFF03
    # CECTL1
    PutLong $DEV [expr $ctrlr_base + 0x04] 0 0xFFFFFF03
    # CECTL2
    PutLong $DEV [expr $ctrlr_base + 0x10] 0 0xFFFFFF03
    # CECTL3
    PutLong $DEV [expr $ctrlr_base + 0x14] 0 0xFFFFFF03

  }

}


if { [string equal $cpu_type "TMS320C64PLUS"] } {

  if { $xbus_width == 2 } {
    # initialize all CE spaces to 32-bit wide async mem 
    puts "Initializing EMIFA @$ctrlr_base to 32-bit wide async mode..." 

    # CE2CFG
    PutLong $DEV [expr $ctrlr_base + 0x0080] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0080] 0 0x0FFFFFFE
    # CE3CFG
    PutLong $DEV [expr $ctrlr_base + 0x0084] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0084] 0 0x0FFFFFFE
    # CE4CFG
    PutLong $DEV [expr $ctrlr_base + 0x0088] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0088] 0 0x0FFFFFFE
    # CE5CFG
    PutLong $DEV [expr $ctrlr_base + 0x008C] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x008C] 0 0x0FFFFFFE

  } elseif { $xbus_width == 1 }  { 
    # initialize all CE spaces to 16-bit wide async mem 
    puts "Initializing EMIFA @$ctrlr_base to 16-bit wide async mode..." 

    # CE2CFG
    PutLong $DEV [expr $ctrlr_base + 0x0080] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0080] 0 0x0FFFFFFD
    # CE3CFG
    PutLong $DEV [expr $ctrlr_base + 0x0084] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0084] 0 0x0FFFFFFD
    # CE4CFG
    PutLong $DEV [expr $ctrlr_base + 0x0088] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0088] 0 0x0FFFFFFD
    # CE5CFG
    PutLong $DEV [expr $ctrlr_base + 0x008C] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x008C] 0 0x0FFFFFFD
  } else {
    # initialize all CE spaces to 8-bit wide async mem 
    puts "Initializing EMIFA @$ctrlr_base to 8-bit wide async mode..." 

    # CE2CFG
    PutLong $DEV [expr $ctrlr_base + 0x0080] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0080] 0 0x0FFFFFFC
    # CE3CFG
    PutLong $DEV [expr $ctrlr_base + 0x0084] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0084] 0 0x0FFFFFFC
    # CE4CFG
    PutLong $DEV [expr $ctrlr_base + 0x0088] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x0088] 0 0x0FFFFFFC
    # CE5CFG
    PutLong $DEV [expr $ctrlr_base + 0x008C] 0 0x0
    PutLong $DEV [expr $ctrlr_base + 0x008C] 0 0x0FFFFFFC
  }

}

if { [string equal $cpu_type "TMS320C6720"] } {

  #NANDFCR
  PutLong $DEV [expr $ctrlr_base + 0x0060] 0 0x0

  if { $xbus_width == 2 } {
    # initialize all CE spaces to 32-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 32-bit wide async mode..." 

    #A1CR
    PutLong $DEV [expr $ctrlr_base + 0x0010] 0 0x3FFFFFFE

  } elseif { $xbus_width == 1 } { 
    # initialize all CE spaces to 16-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 16-bit wide async mode..." 

    #A1CR
    PutLong $DEV [expr $ctrlr_base + 0x0010] 0 0x3FFFFFFD

  } else {
    # initialize all CE spaces to 8-bit wide async mem 
    puts "Initializing EMIF @$ctrlr_base to 8-bit wide async mode..." 

    #A1CR
    PutLong $DEV [expr $ctrlr_base + 0x0010] 0 0x3FFFFFFC

  }
}
